# KBLE, a KeyBoard driven Level Editor
A work in progress level editor with extensive keyboard support.
Designed for tile based 2D platformers.
This is a work in progress program in unusable state.

# Short term design decisions
Subject to change.
* Fully keyboard driven modal editing. Mouse support is secondary.
* GUI application made in [Zig](https://ziglang.org/) with
  [raylib](https://www.raylib.com/).
* Configurable (format unknown).
* [LDtk](https://ldtk.io/) inspired tiling rulesets.

# Build instructions
Build requirements: [Zig](https://ziglang.org/download/) master branch,
[raylib](https://www.raylib.com). For Arch users, `zig-git` is available
in the AUR.
```sh
$ # Clone this repository
$ git clone https://git.sr.ht/~kikoodx/kble && cd kble
$ zig build run
```
Press escape to close the program.

# Default keybindings
Movement, hold Shift to expand selection:
* `h`: left
* `j`: down
* `k`: up
* `l`: right
* `y`: up-left
* `u`: up-right
* `b`: down-left
* `n`: down-right
* `<space>`: reset selection

Actions:
* `d`: delete selection
* `r`: replace selection
* `+`: increase scale (zoom)
* `-`: decrease scale (dezoom)
* `=`: reset scale

# Mouse control
Right click and left click are the same, except right click reset
selection before taking effect.
* Click: free selection.
* Shift + Click: rectangle selection.
* Click while selecting: end selection.

# License
Copyright (c) 2021 KikooDX

This project is under the MIT license.
See LICENSE for more details.
